﻿using Syncfusion.XlsIO;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ImportExcel
{
    public partial class frmImportExcel : Form
    {
        public frmImportExcel()
        {
            InitializeComponent();
        }

        private void btnSelectFile_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFile = new OpenFileDialog();
            openFile.Title = "Select Excel File";
            openFile.Multiselect = false;
            openFile.FileName = txtFilePath.Text;
            openFile.Filter = string.Concat("Excel Worksheets ",
                        "(*.xls, *.xlsx, *.xlsm)|*.xls;*.xlsx;*.xlsm");
            openFile.CheckFileExists = true;
            DialogResult result = openFile.ShowDialog();
            if (result != System.Windows.Forms.DialogResult.OK)
                return;
            openFile.CheckPathExists = true;

            FileInfo fileInfo = new FileInfo(openFile.FileName);
            ExcelEngine engine = null;
            IApplication excelApp = null;
            IWorkbook workbook = null;

            try
            {
                engine = new ExcelEngine();
                excelApp = engine.Excel;
                workbook = excelApp.Workbooks.OpenReadOnly(fileInfo.FullName); 
                DataSet data = new DataSet();
                DataTable sheetData = null;

                foreach (IWorksheet sheet in workbook.Worksheets)
                {
                    if (sheet.UsedRange.Count == 0)
                        continue;

                    sheetData = sheet.ExportDataTable(sheet.UsedRange,
                        ExcelExportDataTableOptions.ComputedFormulaValues);

                    if (sheetData != null)
                        break;
                }
                dgvData.DataSource = sheetData;
            }

            catch
            {
            }
        }
    }
}
